Subject: [Bier] Possible conflict between nibble value in RFC 8296 and IANA registry of IP version number

From: Greg Mirsky <[email-masked]>
Date: Fri, 23 Mar 2018 12:10:26 +0000

Dear All,
RFC 8296 explains the nibble field on BIER header as:
   Nibble:

      This field is set to the binary value 0101; this ensures that the
      MPLS ECMP logic will not confuse the remainder of the BIER header
      with an IP header or with the header of a pseudowire packet.  In
      an MPLS network, if a BFR receives a BIER packet with any other
      value in the first nibble after the label stack, it SHOULD discard
      the packet and log an error.

But IANA registry for IP version numbers
<https://www.iana.org/assignments/version-numbers/version-numbers.xhtml>
reflects allocation of 5 for ST RFC 1819 (thanks to Loa for pointing me to
the registry):

Decimal Keyword Version Reference
0-1 Reserved [Jon_Postel][RFC4928]
2-3 Unassigned [Jon_Postel]
4 IP Internet Protocol [RFC791][Jon_Postel]
5 ST ST Datagram Mode [RFC1819][Jim_Forgie]
6 IPv6 Internet Protocol version 6 [RFC8200]
7 TP/IX TP/IX: The Next Internet [RFC6814]
8 PIP The P Internet Protocol [RFC1621]
9 TUBA TUBA [RFC1347]
10-14 Unassigned [Jon_Postel]
15 Reserved [Jon_Postel]

Perhaps ST Datagram never saw the light of deployment but, as it looks, we
may have formal conflict at hand. The way to remedy the situation may be to
re-assign value 5 to BIER or, at the minimum, make it reserved.
What do you think?

Regards,
Greg

---

From: "徐小虎(义先)" <[email-masked]>
Date: Fri, 23 Mar 2018 20:26:59 +0800

Hi Greg,
Thanks for raising this issue.
As had been said in (https://tools.ietf.org/html/draft-xu-mpls-sr-over-ip-00#page-9) as follows:
"   The MPLS label stack has no explicit protocol identifier field to
   indicate the protocol type of the MPLS payload.  This document
   proposes a mechanism for containing a protocol identifier field
   within the MPLS packet, which is useful for any new encapsulation
   header which may need to be encapsulated with an MPLS header.  With
   this explicit protocol identifier field, there is no need any more
   for each new encapsulation header to deal with the notorious first
   nibble issue associated with MPLS individually.  More specifically,
   there is no need to intentionally avoid the first nibble of each new
   encapsulation header from being 0100 (IPv4) or 0110 (IPv6) and even
   worsely misuse the first nibble of each new encapsulation header as
   an MPLS payload type field (e.g., MPLS-BIER
   [I-D.ietf-bier-mpls-encapsulation]).  The tacit permission of
   misusing the first nibble of each new encapsulation header as an MPLS
   payload type field would exhause the valuable nibble space quickly."I strongly believe the MPLS community should start to consider how to deal with the nibble issue caused by the lack of a protocol field in the MPLS architecture, rather than leaving this issue to each new encapsulation.
Best regards,Xiaohu------------------------------------------------------------------Greg Mirsky <[email-masked]>2018年3月23日(星期五) 20:11BIER WG <[email-masked]>; Loa Andersson <[email-masked]>[Bier] Possible conflict between nibble value in RFC 8296 and IANA registry of IP version number
Dear All,RFC 8296 explains the nibble field on BIER header as:   Nibble:
      This field is set to the binary value 0101; this ensures that the      MPLS ECMP logic will not confuse the remainder of the BIER header      with an IP header or with the header of a pseudowire packet.  In      an MPLS network, if a BFR receives a BIER packet with any other      value in the first nibble after the label stack, it SHOULD discard      the packet and log an error.
But IANA registry for IP version numbers reflects allocation of 5 for ST RFC 1819 (thanks to Loa for pointing me to the registry):
Decimal 	Keyword 	Version 	Reference 0-1		Reserved	[Jon_Postel][RFC4928]2-3		Unassigned	[Jon_Postel]4	IP	Internet Protocol	[RFC791][Jon_Postel]5	ST	ST Datagram Mode	[RFC1819][Jim_Forgie]6	IPv6	Internet Protocol version 6	[RFC8200]7	TP/IX	TP/IX: The Next Internet	[RFC6814]8	PIP	The P Internet Protocol	[RFC1621]9	TUBA	TUBA	[RFC1347]10-14		Unassigned	[Jon_Postel]15		Reserved	[Jon_Postel]
Perhaps ST Datagram never saw the light of deployment but, as it looks, we may have formal conflict at hand. The way to remedy the situation may be to re-assign value 5 to BIER or, at the minimum, make it reserved.What do you think?
Regards,Greg

---

From: Eric C Rosen <[email-masked]>
Date: Fri, 23 Mar 2018 13:09:54 -0400

This issue was discussed extensively on the mailing list in April of 
2016.  You may wish to consult the archives, look for the subject "The 
first nibble issue associated with MPLS encapsulation".

The conflict you mention below does not exist because the first nibble 
of the BIER encapsulation is not a value taken from the "IP Version 
Number" registry.

BTW,  ST was actually deployed in the 1970's and it is possible that a 
few ST implementations were still around in the early-to-mid 1980's.

On 3/23/2018 8:10 AM, Greg Mirsky wrote:
> <https://urldefense.proofpoint.com/v2/url?u=https-3A__www.iana.org_assignments_version-2Dnumbers_version-2Dnumbers.xhtml&d=DwMFaQ&c=HAkYuh63rsuhr6Scbfh0UjBXeMK-ndb3voDTXcWzoCI&r=-DXB84eU9m4cIlq2OOcCJCQQAwJXQQswyu3F0kG0VNo&m=qBfmUmqT2F34aAOWqRNReo3_XIMvcBGSqsnmIh1Z5oM&s=BX_OgisR1iQa9oJZq_YDewd6VDPmLJIYWVHeWk69SeA&e=> 
> reflects allocation of 5 for ST RFC 1819 (thanks to Loa for pointing 
> me to the registry):
>
> 0-1Reserved[Jon_Postel][RFC4928]
> 2-3Unassigned[Jon_Postel]
> 4IPInternet Protocol[RFC791][Jon_Postel]
> 5STST Datagram Mode[RFC1819][Jim_Forgie]
> 6IPv6Internet Protocol version 6[RFC8200]
> 7TP/IXTP/IX: The Next Internet[RFC6814]
> 8PIPThe P Internet Protocol[RFC1621]
> 9TUBATUBA[RFC1347]
> 10-14Unassigned[Jon_Postel]
> 15Reserved[Jon_Postel]
>
> Perhaps ST Datagram never saw the light of deployment but, as it 
> looks, we may have formal conflict at hand. The way to remedy the 
> situation may be to re-assign value 5 to BIER or, at the minimum, make 
> it reserved.
> What do you think?
>
> Regards,
> Greg
>
>
> _______________________________________________
> BIER mailing list
> [email-masked]
> https://urldefense.proofpoint.com/v2/url?u=https-3A__www.ietf.org_mailman_listinfo_bier&d=DwICAg&c=HAkYuh63rsuhr6Scbfh0UjBXeMK-ndb3voDTXcWzoCI&r=-DXB84eU9m4cIlq2OOcCJCQQAwJXQQswyu3F0kG0VNo&m=qBfmUmqT2F34aAOWqRNReo3_XIMvcBGSqsnmIh1Z5oM&s=WHbowmfFpDGB5f6Gy-lmsb6F0-tvDIXeu6eQgZQ7rks&e=